#!/bin/sh
# Setup for this script:
# dnf install nodejs-yarn git $(cat gateway-unbundle.list | while read line; do echo "nodejs-$line"; done)
#

#version=$(rpm -q --specfile --qf='%{version}\n' gateway.spec | head -n1)
version=0.4.0

## Download and setup code
git clone https://github.com/mozilla-iot/gateway-addon-node.git
mv gateway-addon-node gateway-addon-node-$version
cd gateway-addon-node-$version
rm -rf .git

## Download npm libraries, except for sqlite3
sed -i "/sqlite3/d" package.json
sed -i "s|\(.*ajv.*\),|\1|" package.json
yarnpkg --ignore-optional
sed -i "s|.*ajv.*|&,\n    \"sqlite3\": \"^4.0.0\"|" package.json

## Clean out binary modules (and deps) and link to rpm packages
echo "Removing modules that we already have as packages "
for module in $(cat ../gateway-addon-node-unbundle.list)
do
  echo -n "."
  rm -rf node_modules/$module
  ln -s /usr/lib/node_modules/$module node_modules/
  for line in $(find . -type d -name $module | grep node_modules/$module$)
  do
    if ! [ -L $line ] ; then
      echo -n "$(echo $line | tr -cd '/' | wc -c)"
      rm -rf $line
      ln -s /usr/lib/node_modules/$module $line
    fi
  done
done
echo
cd ..
tar cfz gateway-addon-node-v$version.tar.gz gateway-addon-node-$version
